
var spreadNS = GC.Spread.Sheets;

function CustomNumberFormat() {}

CustomNumberFormat.prototype = new GC.Spread.Formatter.FormatterBase();

CustomNumberFormat.prototype.format = function (obj, formattedData) {
    if (typeof obj === "number") {
        return formatNumber(obj, formattedData);
    } else if (typeof obj === "string") {
        if (Number.isFinite(obj)) {
            return formatNumber(parseFloat(obj), formattedData);
        }
    }
    return obj ? obj.toString() : "";
};

let formatter = new GC.Spread.Formatter.GeneralFormatter('# ## ## ## ## ## ## ## ## ## ## ## ## ###.00;[RED]-# ## ## ## ## ## ## ## ## ## ## ## ## ###.00',0,'en-us');
//let formatter = new GC.Spread.Formatter.GeneralFormatter('#,##0.00;[RED]-#,##0.00',0,'en-us');

let gs=','
let ds='.'

function formatNumber(value, formattedData) {
	
	formatter.format(value,formattedData);
	
	let content=[];
	let pushToContent=false;
	formattedData.content.forEach(item=>{
		switch(item.type){
			case "decimalSeparator": 
				item.value=ds;
				content.push(item);
				break;
				
			case "groupSeparator" : 
				item.value=gs;
				content.push(item);
				break;
			
			case "text" : 
				
				if(item.value===' '){
					if(pushToContent){
						item.value=gs;
						content.push(item);
					}
				} else {
					content.push(item);
				}
				break
				
			case "number" : 
				content.push(item);	
				pushToContent=true;
				break;
				
			default:
				content.push(item);	
				
		}
	})
	formattedData.content = content;
	console.log(formattedData);
	return value;
	
}

CustomNumberFormat.prototype.parse = function (str) {
    return new GC.Spread.Formatter.GeneralFormatter().parse(str);
};

window.onload = function () {
    var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {sheetCount: 1});
    initSpread(spread);
};

function initSpread(spread) {
    var sheet = spread.getSheet(0);

    spread.suspendPaint();

    sheet.name("Custom Formatter");
    initData(sheet);

    spread.resumePaint();
};

function initData(sheet) {
    sheet.setArray(0, 0, [[123456789.123, 123456789],]);

    for (var c = 0; c < 2; c++) {
        sheet.autoFitRow(c);
		sheet.autoFitColumn(c);
    }

    sheet.getRange(0, 0, 6, 2).formatter(new CustomNumberFormat());
    
    sheet.setText(0, 0, "Custom Number", spreadNS.SheetArea.colHeader);
    sheet.setText(0, 1, "Custom Date", spreadNS.SheetArea.colHeader);
};
  
